
/**
 * @Communicator.java
 * 
 * Skter kommunikationen fr Drawapplikationen
 * Skickar och tar emot via UDP.
 * ndrad version av communicator frn ip4.2.1
 * S den kan anvndas fr worm spelet.
 * Skickar och tar Emot Direction instanser istllet fr Point.
 *
 * @Author: Karl-Adam karlsson
 * 
 * @version 1.0 06/10/17
 *
 *
 */

 import java.util.LinkedList;
 import java.io.*;
 import java.net.*;
import java.awt.*;
import java.util.*;
 
 public class Communicator implements Runnable{
 	 private int port;
 	 private int remotePort;
 	 InetAddress remAddress;
 	 private Paper myPaper;
     public DatagramSocket sendSock = null;
     public DatagramSocket getSock = null;
     private InetAddress server = null;
     public Gamehandler myGame;
     private Thread gameThread;
     public boolean run;
    // private Draw someDraw;
 	 
 	 /*
 	  * Konstruktor, fixar iordning sockets och allt som behvs fr att UDP:a
 	  * @param String host, the Name of the host.
 	  * @param int aPort, The port on which to communicate
 	  * @param Draw aDrawApp An instance of the Draw application.
 	  * @param int starter, Will be one if you initiated the game, 2 if not.
 	  *
 	  */
 	 public Communicator(int aPort, Paper apaper, String remHost, int remPort, int starter, Thread someThread,Draw aDraw){
 	 	//someDraw = null;
 	 	run = true;
 	 	remotePort = remPort;
 	 	port = aPort;
 	 	myPaper = apaper;
 	 	myGame = new Gamehandler(starter,myPaper,someThread, aDraw,this);
 	 	gameThread = new Thread(myGame);
 	 	
 	 	
 	 	// Skapar sockets, en fr send och end fr receive.
 	 	try {
      		remAddress = InetAddress.getByName(remHost);
      		sendSock = new DatagramSocket();
    	}
    		catch (IOException exE) {
     		//System.err.println(exE);
      		//System.exit(1);
      		System.out.println("EXCEPTION CREATING GAME CONNECTION. IF YOU ARE ALREADY RUNNING A GAME,");
    		System.out.println("TRY LATER, YOU MAY ONLY PLAY ONE GAME AT A TIME.");
    	}
    	////
    	try {
      		getSock = new DatagramSocket(aPort);
      		getSock.setSoTimeout(50);
      		gameThread.start();
    	}
    		catch (IOException ex) {
     		//System.err.println(ex);
      		//System.exit(1);
      		System.out.println("EXCEPTION CREATING GAME CONNECTION. IF YOU ARE ALREADY RUNNING A GAME,");
    		System.out.println("TRY LATER, YOU MAY ONLY PLAY ONE GAME AT A TIME.");
    	}
    
 	 }//End of Constructor
 	 
 	 /*
 	  * Skapar ett DataGramPacket av en Point p
 	  * och skickar ivg det hela.
 	  * @param Point p pointen som skall skickas
 	  */
 	 public void packAndsend(Direction p){
 	 	ByteArrayOutputStream byteStream = new ByteArrayOutputStream(1024);
 	 	//System.out.println("SENDING");
 	 	
 	 	try {
      		ObjectOutputStream outS = new ObjectOutputStream(new BufferedOutputStream(byteStream));
        	outS.flush();
      		outS.writeObject(p);
      		outS.flush();
        	//Fixar byte array
       		byte[] sendBuffer = byteStream.toByteArray();
        	DatagramPacket aPacket = new DatagramPacket(sendBuffer, sendBuffer.length, remAddress, remotePort);  
        	sendSock.send(aPacket);
      		
    	}
    	catch (IOException ioex) {
     		System.err.println(ioex);
    	}
 	 }
 	 
 	 // japp, stnger helt enkelt.
 	 public void closeSockets(){
 	 	sendSock.close();
 	 	getSock.close();
 	 	sendSock.disconnect();
 	 	getSock.disconnect();
 	 }
 	 
 	// sets run
 	public void setRun(boolean b/*, Draw aDraw*/){
 		run = b;
 		//someDraw = aDraw;
 	}
 	//getter
 	public boolean getRun(){
 		return this.run;
 	}
 	
 	
 	
 	/*
 	 * Run,
 	 * tar emot ett DataGramPacket via getSock , gr om
 	 * till Direction och ndrar fiendens direction
 	 * Sover 50ms varje loop.
 	 *
 	 * Nr loopen e slut stngs sockets.
 	 * Stter ocks run fr mygame till false, s den trden lugnar ned sig.
 	 */
 public void run(){
 	DatagramPacket incoming;
 	//gameThread.run();
 	
    while ( this.getRun()==true ) {
    	byte[] buffer = new byte[1024]; 
    	incoming = new DatagramPacket(buffer, buffer.length);
    	
    	
      try {
        incoming.setLength(buffer.length);
        
        
        if(!getSock.isClosed() ){
        	
	        getSock.receive(incoming);
            int byteCount = incoming.getLength();
            
            }
      		ByteArrayInputStream byteStr = new ByteArrayInputStream(buffer);
        ObjectInputStream is = new ObjectInputStream(new BufferedInputStream(byteStr));
        try{
        	Object o = is.readObject();
        	 is.close();
        	 
        	myGame.setEnemyDir((Direction)o);
        }catch(ClassNotFoundException cE){System.err.println(cE);}
       
      }catch (SocketTimeoutException ex) {
        //KOMMER ATT HNDA D OCH D.
        //S INGEN IDE ATT SKRIVA UT NGT
        // DET SKA FAKTISKT HNDA.
      }
      catch (IOException ex) {
        System.err.println("Exception:  " + ex);
      				ex.printStackTrace();
      }
      try{
	      Thread.sleep(100);
	      }catch(InterruptedException iEX){System.err.println(iEX);}
    }
    
    //SLUT P WHILE RUN
    //System.out.println("STNGER OSS NU!!!!!!!!!!!!");
    myGame.run = false;
    closeSockets();
 	//someDraw.dispose();
 	//System.out.println("END OF RUN");

   }
}	