/**
 * @ioHandler.java
 *
 * Klass som hanterar trafiken,
 * skickar och ytar emot meddelanden.
 *
 * @author Karl-Adam Karlsson
 * @version 1.0 06/10/01
 *
 *
 */
 
 import java.util.LinkedList;
 import java.io.*;
 import java.net.*;
 import java.awt.*;
 import java.util.*;
 
 public class ioHandler implements Runnable{
 	 
 	 private int port;
 	 private int remPort;
     private DatagramSocket sendSock = null;
     private DatagramSocket getSock = null;
     //private InetAddress server = null;
     public LinkedList clients;
     CryptHandler myCryptHandler;
 	 ClientUI myChat;
 
 	 
 	 /*
 	  * Konstruktor, fixar iordning sockets och allt som behvs fr att UDP:a
 	  *
 	  */
 	 public ioHandler(ClientUI aChat, String keypath){
 	 	remPort = 2345;
 	 	port = 2345;
 	 	myChat = aChat;
 	 	clients = new LinkedList();
 	 	myCryptHandler = new CryptHandler(keypath);
 	 
 	 	
 	 	// Skapar sockets, en fr send och end fr receive.
 	 	try {
      		//remAddress = InetAddress.getByName(remHost);
      		sendSock = new DatagramSocket();
    	}
    		catch (IOException exE) {
     		System.err.println(exE);
      		System.exit(1);
    	}
    	////
    	try {
      		getSock = new DatagramSocket(port);
    	}
    		catch (IOException ex) {
     		System.err.println(ex);
      		System.exit(1);
    	}
 	 }//End of Constructor
 	 
 	 /*
 	 * Anropas nr man vill skicka meddelande, skickar det.
 	 *
 	 */
 	public void sendMess(Message aMess){
 		ByteArrayOutputStream byteStream = new ByteArrayOutputStream(1024);
 		//System.out.println("MESSAGE TYPE: " + aMess.type());
 	 	
 		try {
      		ObjectOutputStream outS = new ObjectOutputStream(new BufferedOutputStream(byteStream));
      		
      			//KRYPTERA DATAT, dvs textstrngen
 					if(aMess.type()==Message.MESSAGE_MESSAGE){
 							aMess.setText( myCryptHandler.encrypt(aMess.getText()) );
 					}
      		
        	outS.flush();
      		outS.writeObject(aMess);
      		outS.flush();
        	
        	if(aMess.type()==Message.MESSAGE_MESSAGE||aMess.type()==Message.MESSAGE_DISCONNECT){
 					// Detta skall skickas till alla som e connected.
 					
 				
 					
 					//System.out.println("NOCLIENTS:  "  +clients.size());
 					
 					for(int i=0;i<clients.size();i++){
 							//Set up printstream for each
							try {
   								//output = new PrintStream( ((Client)clients.get(i)).getSocket().getOutputStream());
   								//output.print(messages.getFirst());
   								//output.close();
   									byte[] sendBuffer = byteStream.toByteArray();
        							DatagramPacket aPacket = new DatagramPacket(sendBuffer, sendBuffer.length, ((Client)clients.get(i)).getAddress(), remPort);  
        							sendSock.send(aPacket);
							}
							catch (IOException e) {
								System.out.println("Exception, creating PrintStream");
   								System.out.println(e);
							}
 					}//END of for
 				}//end of if
 				else if(aMess.type()==Message.MESSAGE_CHALLENGE||aMess.type()==Message.MESSAGE_CH_REPLY){
 					//SKALL ENDAST SKICKAS TILL DEN VI VILL SPELA MED.
 					try {
   							byte[] sendBuffer = byteStream.toByteArray();
   							System.out.println("DATA TO SEND: " +aMess.getText());
        					DatagramPacket aPacket = new DatagramPacket(sendBuffer, sendBuffer.length, aMess.getTargetIP(), remPort);  
        					sendSock.send(aPacket);
							
							}
							catch (IOException e) {
								System.out.println("Exception, creating PrintStream");
   								System.out.println(e);
							}
 					
 					
 				}else if(aMess.type()==Message.MESSAGE_CONNECT){
 					//System.out.println("Connecting to: " + aMess.getTargetIP().getHostAddress()  );
 					//SKALL ENDAST SKICKAS TILL DEN VI VILL CONNECTA TILL
 					try {
   							//output = new PrintStream( ((Client)clients.get(i)).getSocket().getOutputStream());
   							//output.print(messages.getFirst());
   							//output.close();
   							byte[] sendBuffer = byteStream.toByteArray();
        					DatagramPacket aPacket = new DatagramPacket(sendBuffer, sendBuffer.length, aMess.getTargetIP(), remPort);  
        					sendSock.send(aPacket);
							
							}
							catch (IOException e) {
								System.out.println("Exception, creating PrintStream");
   								System.out.println(e);
							}
 					
 				}else if(aMess.type()==Message.MESSAGE_USR_LIST){
 					//System.out.println("Submitting userlist to: " + aMess.getTargetIP().getHostAddress());
 					
 					try {
   							//output = new PrintStream( ((Client)clients.get(i)).getSocket().getOutputStream());
   							//output.print(messages.getFirst());
   							//output.close();
   							byte[] sendBuffer = byteStream.toByteArray();
        					DatagramPacket aPacket = new DatagramPacket(sendBuffer, sendBuffer.length, aMess.getTargetIP(), remPort);  
        					sendSock.send(aPacket);
							
							}
							catch (IOException e) {
								System.out.println("Exception, creating PrintStream");
   								System.out.println(e);
							}
 				}
 			}
    	catch (IOException ioex) {
     		System.err.println(ioex);
    	}
 	}
 	 

 	
 	/*
 	 * Creates a connectmessage and sends it by calling sendMess()
 	 * @param STring ipNo Ip number to connect to.
 	 *
 	 */
 	public void connectTo(String ipNo){
 		Message aMessage = new Message(Message.MESSAGE_CONNECT);
 		
 		try{
 		
 			aMessage.setData(myChat.me.getName(), myChat.me.getAddress(), InetAddress.getByName(ipNo) );
 		}catch(UnknownHostException uho){
 			uho.printStackTrace();
 				
 		}
 		
 		sendMess(aMessage);
 		
 	}
 	
 	
 	/*
 	 * Run,
 	 * tar emot ett DataGramPacket via getSock , gr om
 	 * till Object och anropar drawPoint hos MyPaper.
 	 * Sover 50ms varje loop.
 	 *
 	 */
 public void run(){
 	DatagramPacket incoming;
 	
    while (true) {
    	byte[] buffer = new byte[1024];
    	incoming = new DatagramPacket(buffer, buffer.length);
    	
    	
      try {
      	
        incoming.setLength(buffer.length);
        getSock.receive(incoming);
        
        int byteCount = incoming.getLength();
      	ByteArrayInputStream byteStr = new ByteArrayInputStream(buffer);
        ObjectInputStream is = new ObjectInputStream(new BufferedInputStream(byteStr));
        try{
        	// System.out.println("INNEN READOBJECT");
        	 Object o = is.readObject();
        	// System.out.println("MESSAGE RECEIVED");
        	 is.close();
        	 Message mess = (Message)o;
        	// System.out.println("NEW MESSSAGE");
        	 
        	 if(mess.type()==Message.MESSAGE_MESSAGE){
        	 
        	 	myChat.printMessage( myCryptHandler.decrypt( mess.getText() ) );
        	 	
        	 }else if(mess.type()==Message.MESSAGE_CONNECT){
        	 	System.out.println("Received Connect!");
        	 	System.out.println("SENDING LIST TO: "+mess.getSenderIP().getHostAddress());
        	 	
        	 	
        	 	
        	 	//Sends a message to the sender of Client with this userlist
        	 	Message usrMess = new Message(Message.MESSAGE_USR_LIST);
        	 	
        	 	
        	 	// KLonar oss fr ivgskickning, mste stta handler till null,
        	 	// eftersom denna ej r serializable.
        	 	Client avgClient = new Client( myChat.me.getName(), myChat.me.getCrypto(), myChat.me.getAddress() );
        	 	avgClient.setHandler(null);
        	 	
        	 	clients.addFirst(avgClient);
        	 	
        	 	usrMess.setData(clients, myChat.me.getAddress(),mess.getSenderIP() );
        	 	sendMess(usrMess);
        	 	
        	 	//Constructs a new client and adds it to the linked list and 
        	 	//to the UI, must be done AFTER we submit our userlist.
        	 	
        	 	Client aClient = new Client(mess);
        	 	clients.addLast(aClient);
        	 	myChat.printMessage("<SYSTEM: > " + aClient.getName() +" has connected to the chat.");
        	 	myChat.addUser(aClient);
        	 	clients.removeFirst();
        	 	
        	 }else if(mess.type()==Message.MESSAGE_DISCONNECT){
        	 	//Hitta rtt person i clients, ta bort, och
        	 	// ta sedan bort rtt nick frn listan i Client UI.
        	 	
        	 	for(int no=0;no<clients.size(); no++){
        	 		//System.out.println("Index " +no +" is:" +((Client)clients.get(no)).getName());
        	 		
        	 		if( ((Client)clients.get(no)).getAddress().equals(mess.getSenderIP())  ){
        	 			myChat.printMessage("<SYSTEM: > " + ((Client)clients.get(no)).getName() +" disconnected.");
        	 			myChat.remUser(((Client)clients.get(no)).getName());
        	 			clients.remove(no);
        	 		
        	 		}
        	 		
        	 	}
        	 	
        	 	
        	 	
        	 }else if(mess.type()==Message.MESSAGE_CHALLENGE){
        	 	//VI FICK EN UTMANING
        	 	myChat.printMessage("<SYSTEM: > "+"Received Challenge from " + mess.getText()+".");
        	 		
        	 			myChat.createGameDialogue(mess);
        	 		
        	 	
        	 }else if(mess.type()==Message.MESSAGE_CH_REPLY){
        	 	//VI FICK SVAR P EN UTMANING
        	 	String s = (String)mess.getData();
        	 	
        	 	if(s.equals("OK") ){
        	 		myChat.printMessage("<SYSTEM: > " + mess.getText() +" accepted our challenge.");
        	 		
        	 		
        	 			new Draw(1, mess.getSenderIP().getHostAddress() ,myChat);
        	 		
        	 	}
        	 	else{
        	 		myChat.printMessage("<SYSTEM: > " + mess.getText() +" rejected our challenge.");
        	 	}
        	 	
        	 }else if(mess.type()==Message.MESSAGE_USR_LIST){
        	 	System.out.println("RECEIVED USR LIST");
        	 	
        	 	if(myChat.me.firstConnect){
        	 		//Om detta e den 1a listan vi fr skall vi connecta till alla.
        	 		LinkedList aList = (LinkedList)mess.getData();
        	 		Client aclient;
        	 	
        	 		
        	 		while (aList.size()>0){
        	 			aclient = (Client)aList.getFirst();
        	 			System.out.println("ADDING CLIENT NAMED: " +aclient.getName());
        	 			
        	 			clients.addLast(aclient);
        	 			myChat.addUser(aclient);
        	 			
        	 			
        	 			if(!aclient.getAddress().equals(mess.getSenderIP()) && !aclient.getAddress().equals(myChat.me.getAddress()) ){
        	 				// Den frsta e personen som skickade listan
        	 				// honom har vi connectat till
        	 				// Resten skall vi ocks connecta till.
        	 				Message aMessage = new Message(Message.MESSAGE_CONNECT);
 							aMessage.setData(myChat.me.getName(), myChat.me.getAddress(), aclient.getAddress() );
 
 							sendMess(aMessage);
        	 			}
        	 			
        	 			aList.removeFirst();
        	 			
        	 		}
        	 		
        	 		myChat.me.firstConnect=false;
        	 	}
        	 	//Annars inget
        	 }
        
        	
        }catch(ClassNotFoundException cE){System.err.println(cE);}
       
      }
      catch (IOException ex) {
        System.err.println("Exception:  " + ex);
      				ex.printStackTrace();
      }
      try{
	      Thread.sleep(30);
	      }catch(InterruptedException iEX){System.err.println(iEX);}
    }

   }
}	